diff a/src/hotspot/cpu/arm/stubDeclarations_arm.hpp b/src/hotspot/cpu/arm/stubDeclarations_arm.hpp
--- a/src/hotspot/cpu/arm/stubDeclarations_arm.hpp
+++ b/src/hotspot/cpu/arm/stubDeclarations_arm.hpp
@@ -24,24 +24,31 @@
  */
 
 #ifndef CPU_ARM_STUBDECLARATIONS_HPP
 #define CPU_ARM_STUBDECLARATIONS_HPP
 
+#define STUBGEN_PREUNIVERSE_BLOBS_ARCH_DO(do_stub,                      \
+                                          do_arch_blob,                 \
+                                          do_arch_entry,                \
+                                          do_arch_entry_init)           \
+  do_arch_blob(preuniverse, 500)                                        \
+  do_stub(preuniverse, atomic_load_long)                                \
+  do_arch_entry(Arm, preuniverse, atomic_load_long,                     \
+                atomic_load_long_entry, atomic_load_long_entry)         \
+  do_stub(preuniverse, atomic_store_long)                               \
+  do_arch_entry(Arm, preuniverse, atomic_store_long,                    \
+                atomic_store_long_entry, atomic_store_long_entry)       \
+
+
 #define STUBGEN_INITIAL_BLOBS_ARCH_DO(do_stub,                          \
                                       do_arch_blob,                     \
                                       do_arch_entry,                    \
                                       do_arch_entry_init)               \
   do_arch_blob(initial, 9000)                                           \
   do_stub(initial, idiv_irem)                                           \
   do_arch_entry(Arm, initial, idiv_irem,                                \
                 idiv_irem_entry, idiv_irem_entry)                       \
-  do_stub(initial, atomic_load_long)                                    \
-  do_arch_entry(Arm, initial, atomic_load_long,                         \
-                atomic_load_long_entry, atomic_load_long_entry)         \
-  do_stub(initial, atomic_store_long)                                   \
-  do_arch_entry(Arm, initial, atomic_load_long,                         \
-                atomic_store_long_entry, atomic_store_long_entry)       \
 
 #define STUBGEN_CONTINUATION_BLOBS_ARCH_DO(do_stub,                     \
                                            do_arch_blob,                \
                                            do_arch_entry,               \
                                            do_arch_entry_init)          \
